# coding: utf-8

"""
    Apprenda.DeveloperPortal.Web

    The Application Management REST API can be leveraged to customize the Developer experience of deploying and managing applications  on the Apprenda Platform. This allows some of the functionality of the Platform's [Developer Portal](/current/developer-portal)to be accomplished through a variety of means such as custom-built UX or command-line interfaces.     ##Authentication    Before making a request, you must be authenticated. Learn how to [get authenticated](/restapi/appmanagement/v1/authentication).    ##Making a Request    ###Prerequisites    * Installed Platform of version 4.5.0 or later     * Authentication token     * To use this API you must be part of a [Development Team or Tenant](/current/create-users) and have an [active subscription](/current/dev-portal-setup#create) to Developer Portal    ###Request URL    All requests must use **https**.    The URL for every request you make is the Cloud URI of your Platform followed by \"/developer\" and the path structure of the endpoint. For example, if your Cloud URI is apps.apprenda.harp and you want to get the Add-ons for your Platform, the request URI will be **apps.apprenda.harp/developer/api/v1/addons**.      For more information, see our documentation on [using API resources](/restapi/appmanagement/v1/resources) and [finding your Cloud URI](/current/clouduri).

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

# python 2 and python 3 compatibility library
from six import iteritems

from apprendaapipythonclient.configuration import Configuration
from apprendaapipythonclient.api_client import ApiClient


class CustomPropertiesApi(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        config = Configuration()
        if api_client:
            self.api_client = api_client
        else:
            if not config.api_client:
                config.api_client = ApiClient()
            self.api_client = config.api_client

    def custom_properties_delete(self, alias, sub_alias, property_name, **kwargs):
        """
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.custom_properties_delete(alias, sub_alias, property_name, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str alias: (required)
        :param str sub_alias: (required)
        :param str property_name: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.custom_properties_delete_with_http_info(alias, sub_alias, property_name, **kwargs)
        else:
            (data) = self.custom_properties_delete_with_http_info(alias, sub_alias, property_name, **kwargs)
            return data

    def custom_properties_delete_with_http_info(self, alias, sub_alias, property_name, **kwargs):
        """
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.custom_properties_delete_with_http_info(alias, sub_alias, property_name, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str alias: (required)
        :param str sub_alias: (required)
        :param str property_name: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['alias', 'sub_alias', 'property_name']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method custom_properties_delete" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'alias' is set
        if ('alias' not in params) or (params['alias'] is None):
            raise ValueError("Missing the required parameter `alias` when calling `custom_properties_delete`")
        # verify the required parameter 'sub_alias' is set
        if ('sub_alias' not in params) or (params['sub_alias'] is None):
            raise ValueError("Missing the required parameter `sub_alias` when calling `custom_properties_delete`")
        # verify the required parameter 'property_name' is set
        if ('property_name' not in params) or (params['property_name'] is None):
            raise ValueError("Missing the required parameter `property_name` when calling `custom_properties_delete`")


        collection_formats = {}

        resource_path = '/api/v1/CustomProperties'.replace('{format}', 'json')
        path_params = {}

        query_params = {}
        if 'alias' in params:
            query_params['alias'] = params['alias']
        if 'sub_alias' in params:
            query_params['subAlias'] = params['sub_alias']
        if 'property_name' in params:
            query_params['propertyName'] = params['property_name']

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'DELETE',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type=None,
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def custom_properties_delete_by_identifier(self, alias, sub_alias, identifier, property_name, **kwargs):
        """
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.custom_properties_delete_by_identifier(alias, sub_alias, identifier, property_name, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str alias: (required)
        :param str sub_alias: (required)
        :param str identifier: (required)
        :param str property_name: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.custom_properties_delete_by_identifier_with_http_info(alias, sub_alias, identifier, property_name, **kwargs)
        else:
            (data) = self.custom_properties_delete_by_identifier_with_http_info(alias, sub_alias, identifier, property_name, **kwargs)
            return data

    def custom_properties_delete_by_identifier_with_http_info(self, alias, sub_alias, identifier, property_name, **kwargs):
        """
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.custom_properties_delete_by_identifier_with_http_info(alias, sub_alias, identifier, property_name, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str alias: (required)
        :param str sub_alias: (required)
        :param str identifier: (required)
        :param str property_name: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['alias', 'sub_alias', 'identifier', 'property_name']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method custom_properties_delete_by_identifier" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'alias' is set
        if ('alias' not in params) or (params['alias'] is None):
            raise ValueError("Missing the required parameter `alias` when calling `custom_properties_delete_by_identifier`")
        # verify the required parameter 'sub_alias' is set
        if ('sub_alias' not in params) or (params['sub_alias'] is None):
            raise ValueError("Missing the required parameter `sub_alias` when calling `custom_properties_delete_by_identifier`")
        # verify the required parameter 'identifier' is set
        if ('identifier' not in params) or (params['identifier'] is None):
            raise ValueError("Missing the required parameter `identifier` when calling `custom_properties_delete_by_identifier`")
        # verify the required parameter 'property_name' is set
        if ('property_name' not in params) or (params['property_name'] is None):
            raise ValueError("Missing the required parameter `property_name` when calling `custom_properties_delete_by_identifier`")


        collection_formats = {}

        resource_path = '/api/v1/CustomProperties/{alias}/{subAlias}/{identifier}'.replace('{format}', 'json')
        path_params = {}
        if 'alias' in params:
            path_params['alias'] = params['alias']
        if 'sub_alias' in params:
            path_params['subAlias'] = params['sub_alias']
        if 'identifier' in params:
            path_params['identifier'] = params['identifier']

        query_params = {}
        if 'property_name' in params:
            query_params['propertyName'] = params['property_name']

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'DELETE',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type=None,
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def custom_properties_delete_by_sub_alias(self, alias, sub_alias, property_name, **kwargs):
        """
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.custom_properties_delete_by_sub_alias(alias, sub_alias, property_name, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str alias: (required)
        :param str sub_alias: (required)
        :param str property_name: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.custom_properties_delete_by_sub_alias_with_http_info(alias, sub_alias, property_name, **kwargs)
        else:
            (data) = self.custom_properties_delete_by_sub_alias_with_http_info(alias, sub_alias, property_name, **kwargs)
            return data

    def custom_properties_delete_by_sub_alias_with_http_info(self, alias, sub_alias, property_name, **kwargs):
        """
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.custom_properties_delete_by_sub_alias_with_http_info(alias, sub_alias, property_name, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str alias: (required)
        :param str sub_alias: (required)
        :param str property_name: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['alias', 'sub_alias', 'property_name']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method custom_properties_delete_by_sub_alias" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'alias' is set
        if ('alias' not in params) or (params['alias'] is None):
            raise ValueError("Missing the required parameter `alias` when calling `custom_properties_delete_by_sub_alias`")
        # verify the required parameter 'sub_alias' is set
        if ('sub_alias' not in params) or (params['sub_alias'] is None):
            raise ValueError("Missing the required parameter `sub_alias` when calling `custom_properties_delete_by_sub_alias`")
        # verify the required parameter 'property_name' is set
        if ('property_name' not in params) or (params['property_name'] is None):
            raise ValueError("Missing the required parameter `property_name` when calling `custom_properties_delete_by_sub_alias`")


        collection_formats = {}

        resource_path = '/api/v1/CustomProperties/{alias}/{subAlias}'.replace('{format}', 'json')
        path_params = {}
        if 'alias' in params:
            path_params['alias'] = params['alias']
        if 'sub_alias' in params:
            path_params['subAlias'] = params['sub_alias']

        query_params = {}
        if 'property_name' in params:
            query_params['propertyName'] = params['property_name']

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'DELETE',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type=None,
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def custom_properties_get(self, alias, sub_alias, **kwargs):
        """
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.custom_properties_get(alias, sub_alias, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str alias: (required)
        :param str sub_alias: (required)
        :return: list[CustomProperty]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.custom_properties_get_with_http_info(alias, sub_alias, **kwargs)
        else:
            (data) = self.custom_properties_get_with_http_info(alias, sub_alias, **kwargs)
            return data

    def custom_properties_get_with_http_info(self, alias, sub_alias, **kwargs):
        """
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.custom_properties_get_with_http_info(alias, sub_alias, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str alias: (required)
        :param str sub_alias: (required)
        :return: list[CustomProperty]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['alias', 'sub_alias']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method custom_properties_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'alias' is set
        if ('alias' not in params) or (params['alias'] is None):
            raise ValueError("Missing the required parameter `alias` when calling `custom_properties_get`")
        # verify the required parameter 'sub_alias' is set
        if ('sub_alias' not in params) or (params['sub_alias'] is None):
            raise ValueError("Missing the required parameter `sub_alias` when calling `custom_properties_get`")


        collection_formats = {}

        resource_path = '/api/v1/CustomProperties'.replace('{format}', 'json')
        path_params = {}

        query_params = {}
        if 'alias' in params:
            query_params['alias'] = params['alias']
        if 'sub_alias' in params:
            query_params['subAlias'] = params['sub_alias']

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json', 'text/json'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'GET',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='list[CustomProperty]',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def custom_properties_get_by_identifier(self, alias, sub_alias, identifier, **kwargs):
        """
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.custom_properties_get_by_identifier(alias, sub_alias, identifier, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str alias: (required)
        :param str sub_alias: (required)
        :param str identifier: (required)
        :return: list[CustomProperty]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.custom_properties_get_by_identifier_with_http_info(alias, sub_alias, identifier, **kwargs)
        else:
            (data) = self.custom_properties_get_by_identifier_with_http_info(alias, sub_alias, identifier, **kwargs)
            return data

    def custom_properties_get_by_identifier_with_http_info(self, alias, sub_alias, identifier, **kwargs):
        """
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.custom_properties_get_by_identifier_with_http_info(alias, sub_alias, identifier, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str alias: (required)
        :param str sub_alias: (required)
        :param str identifier: (required)
        :return: list[CustomProperty]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['alias', 'sub_alias', 'identifier']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method custom_properties_get_by_identifier" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'alias' is set
        if ('alias' not in params) or (params['alias'] is None):
            raise ValueError("Missing the required parameter `alias` when calling `custom_properties_get_by_identifier`")
        # verify the required parameter 'sub_alias' is set
        if ('sub_alias' not in params) or (params['sub_alias'] is None):
            raise ValueError("Missing the required parameter `sub_alias` when calling `custom_properties_get_by_identifier`")
        # verify the required parameter 'identifier' is set
        if ('identifier' not in params) or (params['identifier'] is None):
            raise ValueError("Missing the required parameter `identifier` when calling `custom_properties_get_by_identifier`")


        collection_formats = {}

        resource_path = '/api/v1/CustomProperties/{alias}/{subAlias}/{identifier}'.replace('{format}', 'json')
        path_params = {}
        if 'alias' in params:
            path_params['alias'] = params['alias']
        if 'sub_alias' in params:
            path_params['subAlias'] = params['sub_alias']
        if 'identifier' in params:
            path_params['identifier'] = params['identifier']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json', 'text/json'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'GET',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='list[CustomProperty]',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def custom_properties_get_by_sub_alias(self, alias, sub_alias, **kwargs):
        """
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.custom_properties_get_by_sub_alias(alias, sub_alias, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str alias: (required)
        :param str sub_alias: (required)
        :return: list[CustomProperty]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.custom_properties_get_by_sub_alias_with_http_info(alias, sub_alias, **kwargs)
        else:
            (data) = self.custom_properties_get_by_sub_alias_with_http_info(alias, sub_alias, **kwargs)
            return data

    def custom_properties_get_by_sub_alias_with_http_info(self, alias, sub_alias, **kwargs):
        """
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.custom_properties_get_by_sub_alias_with_http_info(alias, sub_alias, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str alias: (required)
        :param str sub_alias: (required)
        :return: list[CustomProperty]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['alias', 'sub_alias']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method custom_properties_get_by_sub_alias" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'alias' is set
        if ('alias' not in params) or (params['alias'] is None):
            raise ValueError("Missing the required parameter `alias` when calling `custom_properties_get_by_sub_alias`")
        # verify the required parameter 'sub_alias' is set
        if ('sub_alias' not in params) or (params['sub_alias'] is None):
            raise ValueError("Missing the required parameter `sub_alias` when calling `custom_properties_get_by_sub_alias`")


        collection_formats = {}

        resource_path = '/api/v1/CustomProperties/{alias}/{subAlias}'.replace('{format}', 'json')
        path_params = {}
        if 'alias' in params:
            path_params['alias'] = params['alias']
        if 'sub_alias' in params:
            path_params['subAlias'] = params['sub_alias']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json', 'text/json'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'GET',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='list[CustomProperty]',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def custom_properties_get_model(self, model_name, **kwargs):
        """
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.custom_properties_get_model(model_name, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str model_name: (required)
        :return: CustomPropertyModel
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.custom_properties_get_model_with_http_info(model_name, **kwargs)
        else:
            (data) = self.custom_properties_get_model_with_http_info(model_name, **kwargs)
            return data

    def custom_properties_get_model_with_http_info(self, model_name, **kwargs):
        """
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.custom_properties_get_model_with_http_info(model_name, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str model_name: (required)
        :return: CustomPropertyModel
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['model_name']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method custom_properties_get_model" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'model_name' is set
        if ('model_name' not in params) or (params['model_name'] is None):
            raise ValueError("Missing the required parameter `model_name` when calling `custom_properties_get_model`")


        collection_formats = {}

        resource_path = '/api/v1/custompropertymodels/{modelName}'.replace('{format}', 'json')
        path_params = {}
        if 'model_name' in params:
            path_params['modelName'] = params['model_name']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json', 'text/json'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'GET',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='CustomPropertyModel',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def custom_properties_put(self, alias, sub_alias, custom_property, **kwargs):
        """
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.custom_properties_put(alias, sub_alias, custom_property, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str alias: (required)
        :param str sub_alias: (required)
        :param CustomProperty custom_property: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.custom_properties_put_with_http_info(alias, sub_alias, custom_property, **kwargs)
        else:
            (data) = self.custom_properties_put_with_http_info(alias, sub_alias, custom_property, **kwargs)
            return data

    def custom_properties_put_with_http_info(self, alias, sub_alias, custom_property, **kwargs):
        """
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.custom_properties_put_with_http_info(alias, sub_alias, custom_property, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str alias: (required)
        :param str sub_alias: (required)
        :param CustomProperty custom_property: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['alias', 'sub_alias', 'custom_property']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method custom_properties_put" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'alias' is set
        if ('alias' not in params) or (params['alias'] is None):
            raise ValueError("Missing the required parameter `alias` when calling `custom_properties_put`")
        # verify the required parameter 'sub_alias' is set
        if ('sub_alias' not in params) or (params['sub_alias'] is None):
            raise ValueError("Missing the required parameter `sub_alias` when calling `custom_properties_put`")
        # verify the required parameter 'custom_property' is set
        if ('custom_property' not in params) or (params['custom_property'] is None):
            raise ValueError("Missing the required parameter `custom_property` when calling `custom_properties_put`")


        collection_formats = {}

        resource_path = '/api/v1/CustomProperties'.replace('{format}', 'json')
        path_params = {}

        query_params = {}
        if 'alias' in params:
            query_params['alias'] = params['alias']
        if 'sub_alias' in params:
            query_params['subAlias'] = params['sub_alias']

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'custom_property' in params:
            body_params = params['custom_property']
        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/json', 'application/x-www-form-urlencoded'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'PUT',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type=None,
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def custom_properties_put_by_identifier(self, alias, sub_alias, identifier, custom_property, **kwargs):
        """
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.custom_properties_put_by_identifier(alias, sub_alias, identifier, custom_property, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str alias: (required)
        :param str sub_alias: (required)
        :param str identifier: (required)
        :param CustomProperty custom_property: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.custom_properties_put_by_identifier_with_http_info(alias, sub_alias, identifier, custom_property, **kwargs)
        else:
            (data) = self.custom_properties_put_by_identifier_with_http_info(alias, sub_alias, identifier, custom_property, **kwargs)
            return data

    def custom_properties_put_by_identifier_with_http_info(self, alias, sub_alias, identifier, custom_property, **kwargs):
        """
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.custom_properties_put_by_identifier_with_http_info(alias, sub_alias, identifier, custom_property, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str alias: (required)
        :param str sub_alias: (required)
        :param str identifier: (required)
        :param CustomProperty custom_property: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['alias', 'sub_alias', 'identifier', 'custom_property']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method custom_properties_put_by_identifier" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'alias' is set
        if ('alias' not in params) or (params['alias'] is None):
            raise ValueError("Missing the required parameter `alias` when calling `custom_properties_put_by_identifier`")
        # verify the required parameter 'sub_alias' is set
        if ('sub_alias' not in params) or (params['sub_alias'] is None):
            raise ValueError("Missing the required parameter `sub_alias` when calling `custom_properties_put_by_identifier`")
        # verify the required parameter 'identifier' is set
        if ('identifier' not in params) or (params['identifier'] is None):
            raise ValueError("Missing the required parameter `identifier` when calling `custom_properties_put_by_identifier`")
        # verify the required parameter 'custom_property' is set
        if ('custom_property' not in params) or (params['custom_property'] is None):
            raise ValueError("Missing the required parameter `custom_property` when calling `custom_properties_put_by_identifier`")


        collection_formats = {}

        resource_path = '/api/v1/CustomProperties/{alias}/{subAlias}/{identifier}'.replace('{format}', 'json')
        path_params = {}
        if 'alias' in params:
            path_params['alias'] = params['alias']
        if 'sub_alias' in params:
            path_params['subAlias'] = params['sub_alias']
        if 'identifier' in params:
            path_params['identifier'] = params['identifier']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'custom_property' in params:
            body_params = params['custom_property']
        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/json', 'application/x-www-form-urlencoded'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'PUT',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type=None,
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def custom_properties_put_by_sub_alias(self, alias, sub_alias, custom_property, **kwargs):
        """
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.custom_properties_put_by_sub_alias(alias, sub_alias, custom_property, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str alias: (required)
        :param str sub_alias: (required)
        :param CustomProperty custom_property: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.custom_properties_put_by_sub_alias_with_http_info(alias, sub_alias, custom_property, **kwargs)
        else:
            (data) = self.custom_properties_put_by_sub_alias_with_http_info(alias, sub_alias, custom_property, **kwargs)
            return data

    def custom_properties_put_by_sub_alias_with_http_info(self, alias, sub_alias, custom_property, **kwargs):
        """
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.custom_properties_put_by_sub_alias_with_http_info(alias, sub_alias, custom_property, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str alias: (required)
        :param str sub_alias: (required)
        :param CustomProperty custom_property: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['alias', 'sub_alias', 'custom_property']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method custom_properties_put_by_sub_alias" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'alias' is set
        if ('alias' not in params) or (params['alias'] is None):
            raise ValueError("Missing the required parameter `alias` when calling `custom_properties_put_by_sub_alias`")
        # verify the required parameter 'sub_alias' is set
        if ('sub_alias' not in params) or (params['sub_alias'] is None):
            raise ValueError("Missing the required parameter `sub_alias` when calling `custom_properties_put_by_sub_alias`")
        # verify the required parameter 'custom_property' is set
        if ('custom_property' not in params) or (params['custom_property'] is None):
            raise ValueError("Missing the required parameter `custom_property` when calling `custom_properties_put_by_sub_alias`")


        collection_formats = {}

        resource_path = '/api/v1/CustomProperties/{alias}/{subAlias}'.replace('{format}', 'json')
        path_params = {}
        if 'alias' in params:
            path_params['alias'] = params['alias']
        if 'sub_alias' in params:
            path_params['subAlias'] = params['sub_alias']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'custom_property' in params:
            body_params = params['custom_property']
        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/json', 'application/x-www-form-urlencoded'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'PUT',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type=None,
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)
