# coding: utf-8

"""
    Apprenda.DeveloperPortal.Web

    The Application Management REST API can be leveraged to customize the Developer experience of deploying and managing applications  on the Apprenda Platform. This allows some of the functionality of the Platform's [Developer Portal](/current/developer-portal)to be accomplished through a variety of means such as custom-built UX or command-line interfaces.     ##Authentication    Before making a request, you must be authenticated. Learn how to [get authenticated](/restapi/appmanagement/v1/authentication).    ##Making a Request    ###Prerequisites    * Installed Platform of version 4.5.0 or later     * Authentication token     * To use this API you must be part of a [Development Team or Tenant](/current/create-users) and have an [active subscription](/current/dev-portal-setup#create) to Developer Portal    ###Request URL    All requests must use **https**.    The URL for every request you make is the Cloud URI of your Platform followed by \"/developer\" and the path structure of the endpoint. For example, if your Cloud URI is apps.apprenda.harp and you want to get the Add-ons for your Platform, the request URI will be **apps.apprenda.harp/developer/api/v1/addons**.      For more information, see our documentation on [using API resources](/restapi/appmanagement/v1/resources) and [finding your Cloud URI](/current/clouduri).

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class ReportCardSection(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, title=None, success=None, messages=None, begin_date=None, end_date=None, finished=None, canceled=None, operation_type=None):
        """
        ReportCardSection - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'title': 'str',
            'success': 'bool',
            'messages': 'list[ReportCardMessage]',
            'begin_date': 'datetime',
            'end_date': 'datetime',
            'finished': 'bool',
            'canceled': 'bool',
            'operation_type': 'str'
        }

        self.attribute_map = {
            'title': 'title',
            'success': 'success',
            'messages': 'messages',
            'begin_date': 'beginDate',
            'end_date': 'endDate',
            'finished': 'finished',
            'canceled': 'canceled',
            'operation_type': 'operationType'
        }

        self._title = title
        self._success = success
        self._messages = messages
        self._begin_date = begin_date
        self._end_date = end_date
        self._finished = finished
        self._canceled = canceled
        self._operation_type = operation_type

    @property
    def title(self):
        """
        Gets the title of this ReportCardSection.

        :return: The title of this ReportCardSection.
        :rtype: str
        """
        return self._title

    @title.setter
    def title(self, title):
        """
        Sets the title of this ReportCardSection.

        :param title: The title of this ReportCardSection.
        :type: str
        """

        self._title = title

    @property
    def success(self):
        """
        Gets the success of this ReportCardSection.

        :return: The success of this ReportCardSection.
        :rtype: bool
        """
        return self._success

    @success.setter
    def success(self, success):
        """
        Sets the success of this ReportCardSection.

        :param success: The success of this ReportCardSection.
        :type: bool
        """

        self._success = success

    @property
    def messages(self):
        """
        Gets the messages of this ReportCardSection.

        :return: The messages of this ReportCardSection.
        :rtype: list[ReportCardMessage]
        """
        return self._messages

    @messages.setter
    def messages(self, messages):
        """
        Sets the messages of this ReportCardSection.

        :param messages: The messages of this ReportCardSection.
        :type: list[ReportCardMessage]
        """

        self._messages = messages

    @property
    def begin_date(self):
        """
        Gets the begin_date of this ReportCardSection.

        :return: The begin_date of this ReportCardSection.
        :rtype: datetime
        """
        return self._begin_date

    @begin_date.setter
    def begin_date(self, begin_date):
        """
        Sets the begin_date of this ReportCardSection.

        :param begin_date: The begin_date of this ReportCardSection.
        :type: datetime
        """

        self._begin_date = begin_date

    @property
    def end_date(self):
        """
        Gets the end_date of this ReportCardSection.

        :return: The end_date of this ReportCardSection.
        :rtype: datetime
        """
        return self._end_date

    @end_date.setter
    def end_date(self, end_date):
        """
        Sets the end_date of this ReportCardSection.

        :param end_date: The end_date of this ReportCardSection.
        :type: datetime
        """

        self._end_date = end_date

    @property
    def finished(self):
        """
        Gets the finished of this ReportCardSection.

        :return: The finished of this ReportCardSection.
        :rtype: bool
        """
        return self._finished

    @finished.setter
    def finished(self, finished):
        """
        Sets the finished of this ReportCardSection.

        :param finished: The finished of this ReportCardSection.
        :type: bool
        """

        self._finished = finished

    @property
    def canceled(self):
        """
        Gets the canceled of this ReportCardSection.

        :return: The canceled of this ReportCardSection.
        :rtype: bool
        """
        return self._canceled

    @canceled.setter
    def canceled(self, canceled):
        """
        Sets the canceled of this ReportCardSection.

        :param canceled: The canceled of this ReportCardSection.
        :type: bool
        """

        self._canceled = canceled

    @property
    def operation_type(self):
        """
        Gets the operation_type of this ReportCardSection.

        :return: The operation_type of this ReportCardSection.
        :rtype: str
        """
        return self._operation_type

    @operation_type.setter
    def operation_type(self, operation_type):
        """
        Sets the operation_type of this ReportCardSection.

        :param operation_type: The operation_type of this ReportCardSection.
        :type: str
        """
        allowed_values = ["NotApplicable", "Promote", "Rollback"]
        if operation_type not in allowed_values:
            raise ValueError(
                "Invalid value for `operation_type` ({0}), must be one of {1}"
                .format(operation_type, allowed_values)
            )

        self._operation_type = operation_type

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, ReportCardSection):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
