# coding: utf-8

"""
    Apprenda.DeveloperPortal.Web

    The Application Management REST API can be leveraged to customize the Developer experience of deploying and managing applications  on the Apprenda Platform. This allows some of the functionality of the Platform's [Developer Portal](/current/developer-portal)to be accomplished through a variety of means such as custom-built UX or command-line interfaces.     ##Authentication    Before making a request, you must be authenticated. Learn how to [get authenticated](/restapi/appmanagement/v1/authentication).    ##Making a Request    ###Prerequisites    * Installed Platform of version 4.5.0 or later     * Authentication token     * To use this API you must be part of a [Development Team or Tenant](/current/create-users) and have an [active subscription](/current/dev-portal-setup#create) to Developer Portal    ###Request URL    All requests must use **https**.    The URL for every request you make is the Cloud URI of your Platform followed by \"/developer\" and the path structure of the endpoint. For example, if your Cloud URI is apps.apprenda.harp and you want to get the Add-ons for your Platform, the request URI will be **apps.apprenda.harp/developer/api/v1/addons**.      For more information, see our documentation on [using API resources](/restapi/appmanagement/v1/resources) and [finding your Cloud URI](/current/clouduri).

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class SubscribedTenant(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, tenant_alias=None, tenant_name=None, users=None):
        """
        SubscribedTenant - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'tenant_alias': 'str',
            'tenant_name': 'str',
            'users': 'ResourceBase'
        }

        self.attribute_map = {
            'tenant_alias': 'tenantAlias',
            'tenant_name': 'tenantName',
            'users': 'users'
        }

        self._tenant_alias = tenant_alias
        self._tenant_name = tenant_name
        self._users = users

    @property
    def tenant_alias(self):
        """
        Gets the tenant_alias of this SubscribedTenant.

        :return: The tenant_alias of this SubscribedTenant.
        :rtype: str
        """
        return self._tenant_alias

    @tenant_alias.setter
    def tenant_alias(self, tenant_alias):
        """
        Sets the tenant_alias of this SubscribedTenant.

        :param tenant_alias: The tenant_alias of this SubscribedTenant.
        :type: str
        """

        self._tenant_alias = tenant_alias

    @property
    def tenant_name(self):
        """
        Gets the tenant_name of this SubscribedTenant.

        :return: The tenant_name of this SubscribedTenant.
        :rtype: str
        """
        return self._tenant_name

    @tenant_name.setter
    def tenant_name(self, tenant_name):
        """
        Sets the tenant_name of this SubscribedTenant.

        :param tenant_name: The tenant_name of this SubscribedTenant.
        :type: str
        """

        self._tenant_name = tenant_name

    @property
    def users(self):
        """
        Gets the users of this SubscribedTenant.

        :return: The users of this SubscribedTenant.
        :rtype: ResourceBase
        """
        return self._users

    @users.setter
    def users(self, users):
        """
        Sets the users of this SubscribedTenant.

        :param users: The users of this SubscribedTenant.
        :type: ResourceBase
        """

        self._users = users

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, SubscribedTenant):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
