# coding: utf-8

"""
    Platform Operations Rest API

    The Platform Operations REST API can be leveraged to customize the Platform Operator experience of managing infrastructure and applications for the Apprenda Platform. This allows some of the functionality of the Platform's System Operations Center (SOC) to be accomplished through a variety of means such as custom-built UX or command-line interfaces.   For more information about the abilities of Platform Operators, see our documentation on the [SOC](/current/SOC).   ##Authentication   Before making a request, you must be authenticated. Learn how to [get authenticated](/restapi/platformops/v1/authentication).   ##Making a Request   ###Prerequisites   * Installed Platform of version 6.5.1 or later (Note that most endpoints are only available in version 6.7.0 and later)    * Authentication token   * If SOC authorization is enabled on your Platform, you must be assigned as an active Platform Operator   ###Request URL   All requests must use **https**.   The URL for every request you make is the Cloud URI of your Platform followed by \"/soc\" and the path structure of the endpoint. For example, if your Cloud URI is apps.apprenda.harp and you want to get the Add-ons for your Platform, the request URI will be **apps.apprenda.harp/soc/api/v1/addons**.   For more information, see our documentation on [using API resources](/restapi/platformops/v1/using-resources) and [finding your Cloud URI](/current/clouduri).   ###Request Headers   Your authenication token must be passed in the header of all requests using the key **ApprendaSessionToken** (not case sensitive).  

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class ApprendaFileSystemFileSystemUri(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, driver=None, mount_point=None, path=None, separator=None, parameters=None, parent_uri=None):
        """
        ApprendaFileSystemFileSystemUri - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'driver': 'str',
            'mount_point': 'list[str]',
            'path': 'list[str]',
            'separator': 'str',
            'parameters': 'dict(str, str)',
            'parent_uri': 'ApprendaFileSystemFileSystemUri'
        }

        self.attribute_map = {
            'driver': 'driver',
            'mount_point': 'mountPoint',
            'path': 'path',
            'separator': 'separator',
            'parameters': 'parameters',
            'parent_uri': 'parentUri'
        }

        self._driver = driver
        self._mount_point = mount_point
        self._path = path
        self._separator = separator
        self._parameters = parameters
        self._parent_uri = parent_uri

    @property
    def driver(self):
        """
        Gets the driver of this ApprendaFileSystemFileSystemUri.

        :return: The driver of this ApprendaFileSystemFileSystemUri.
        :rtype: str
        """
        return self._driver

    @driver.setter
    def driver(self, driver):
        """
        Sets the driver of this ApprendaFileSystemFileSystemUri.

        :param driver: The driver of this ApprendaFileSystemFileSystemUri.
        :type: str
        """

        self._driver = driver

    @property
    def mount_point(self):
        """
        Gets the mount_point of this ApprendaFileSystemFileSystemUri.

        :return: The mount_point of this ApprendaFileSystemFileSystemUri.
        :rtype: list[str]
        """
        return self._mount_point

    @mount_point.setter
    def mount_point(self, mount_point):
        """
        Sets the mount_point of this ApprendaFileSystemFileSystemUri.

        :param mount_point: The mount_point of this ApprendaFileSystemFileSystemUri.
        :type: list[str]
        """

        self._mount_point = mount_point

    @property
    def path(self):
        """
        Gets the path of this ApprendaFileSystemFileSystemUri.

        :return: The path of this ApprendaFileSystemFileSystemUri.
        :rtype: list[str]
        """
        return self._path

    @path.setter
    def path(self, path):
        """
        Sets the path of this ApprendaFileSystemFileSystemUri.

        :param path: The path of this ApprendaFileSystemFileSystemUri.
        :type: list[str]
        """

        self._path = path

    @property
    def separator(self):
        """
        Gets the separator of this ApprendaFileSystemFileSystemUri.

        :return: The separator of this ApprendaFileSystemFileSystemUri.
        :rtype: str
        """
        return self._separator

    @separator.setter
    def separator(self, separator):
        """
        Sets the separator of this ApprendaFileSystemFileSystemUri.

        :param separator: The separator of this ApprendaFileSystemFileSystemUri.
        :type: str
        """

        self._separator = separator

    @property
    def parameters(self):
        """
        Gets the parameters of this ApprendaFileSystemFileSystemUri.

        :return: The parameters of this ApprendaFileSystemFileSystemUri.
        :rtype: dict(str, str)
        """
        return self._parameters

    @parameters.setter
    def parameters(self, parameters):
        """
        Sets the parameters of this ApprendaFileSystemFileSystemUri.

        :param parameters: The parameters of this ApprendaFileSystemFileSystemUri.
        :type: dict(str, str)
        """

        self._parameters = parameters

    @property
    def parent_uri(self):
        """
        Gets the parent_uri of this ApprendaFileSystemFileSystemUri.

        :return: The parent_uri of this ApprendaFileSystemFileSystemUri.
        :rtype: ApprendaFileSystemFileSystemUri
        """
        return self._parent_uri

    @parent_uri.setter
    def parent_uri(self, parent_uri):
        """
        Sets the parent_uri of this ApprendaFileSystemFileSystemUri.

        :param parent_uri: The parent_uri of this ApprendaFileSystemFileSystemUri.
        :type: ApprendaFileSystemFileSystemUri
        """

        self._parent_uri = parent_uri

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, ApprendaFileSystemFileSystemUri):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
